#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <io.h>

/* sc2000.dat file creator Copyright 1994 by John Stewart see the file
   sc2kutil.txt for info on this program.

   to contact me(the author) try the following:

email: jstewart@sdl.psych.wright.edu or
       jstewart@desire.wright.edu

smail: John Stewart
       3115 Seven Oaks Dr.
       Laura, OH  45337

phone: 513-947-1109

*NOTE: this program needs to be linked to wildargs.obj in the
\borlandc\lib directory(unless you want to manually type in 400
file names) :).

*/

#define MAX_FILES 500

#define MAX_FNAME_LEN 13

typedef struct
{
	unsigned long offset_arr[MAX_FILES];
	char fname_arr[MAX_FILES][MAX_FNAME_LEN];
	unsigned int num_files;
} pfhi_t; /* packed file header info type */


long filesize(FILE *stream)
{
   long curpos, length;

   curpos = ftell(stream);
   fseek(stream, 0L, SEEK_END);
   length = ftell(stream);
   fseek(stream, curpos, SEEK_SET);
   return length;
}

void create_header(int argc, char *argv[], pfhi_t *header_info)
{
int i;
FILE *tmpfp;
	for(i=1;i<argc-1;i++)
	{
		strcpy(header_info->fname_arr[i-1],argv[i]);
		tmpfp=fopen(argv[i],"rb");
		header_info->offset_arr[i-1]=filesize(tmpfp);
		fclose(tmpfp);
	}
	header_info->num_files=argc-2;
}

void view_header(char *fname, pfhi_t *header_info)
{
unsigned int i;

	printf("paking %ld files into file: %s\n",header_info->num_files,fname);

	for(i=0;i<header_info->num_files;i++)
	{
		printf("\tfname: %s, offset=%lu\n",
			  header_info->fname_arr[i],
			  header_info->offset_arr[i]);
	}
}

unsigned long int write_header(char *fname, pfhi_t *header_info)
{
int i;
FILE *outfp;
unsigned long int header_size;
unsigned long int offset;
int zc;

int slen;
	header_size=header_info->num_files*16;

	printf("header size=%lu\n",header_size);

	outfp=fopen(fname,"wb");

	offset=header_size;

	for(i=0;i<header_info->num_files;i++)
	{
		slen=strlen(header_info->fname_arr[i]);

		for(zc=0;zc<slen;zc++)
			fputc(header_info->fname_arr[i][zc],outfp);

/*		fputs(header_info->fname_arr[i],outfp); */

		for(zc=0;zc<12-slen;zc++)
			fputc(0,outfp);

		fwrite(&offset,4,1,outfp);

		offset+=header_info->offset_arr[i];
	}

	fclose(outfp);
}

void append_files(char *fname, pfhi_t *header_info)
{
FILE *outfp;
FILE *infp;

unsigned int i;

unsigned char *buffer;

unsigned long int num_bytes;

	buffer=malloc(32768);

	outfp=fopen(fname,"ab");

	for(i=0;i<header_info->num_files;i++)
	{
		if( ( infp=fopen(header_info->fname_arr[i],"rb") )==NULL)
		{
			printf("Error opening file: %s ...terminating.\n",
				  header_info->fname_arr[i]);
			exit(-1);
		}
		else
			printf("appending: %s\n",
				  header_info->fname_arr[i]);

		num_bytes=header_info->offset_arr[i];

		while(num_bytes)
		{
			fread(buffer, 32768, 1, infp);

			if(num_bytes > 32767)
			{
				fwrite(buffer, 32768, 1, outfp);
				num_bytes-=32768;
			}
			else
			{
				fwrite(buffer, num_bytes, 1, outfp);
				num_bytes=0;
			}
		}
		fclose(infp);


	}
	fclose(outfp);
	free(buffer);


}
void main(int argc, char *argv[], char *envp[])
{
pfhi_t header_info;
unsigned long int header_size;

if(argc<2)
{
	printf("Usage: %s fname1 <fname2> <fname3> ... <fnamen> outfile.pak\n");
	printf("where all arguements are filenames to be packed except the\n");
	printf("last, which is the output file\n");
	exit(-1);
}


	printf("reading file sizes\n");
	create_header(argc, argv, &header_info);
/*	view_header(argv[argc-1], &header_info);*/

	printf("writing header\n");
	header_size=write_header(argv[argc-1], &header_info);
	printf("appending file\n");
	append_files(argv[argc-1], &header_info);

}
















